//========================================================================================================================================================================//
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
//========================================================================================================================================================================//
extern double lotsize;
extern int ma1 =6;
extern int ma2 =18;
extern int ma3 =50;
extern int ma4 =200;

extern double sl=10.0;
extern double tp=20.0;
extern double risk=10.0;
//========================================================================================================================================================================//
int minbar =ma1;
bool canbuy;
bool cansell;
bool buycross=false;
bool sellcross=false;
int CntBuy;
int CntSell;
//========================================================================================================================================================================//
int OnInit()
  {

   return(INIT_SUCCEEDED);
  }
//========================================================================================================================================================================//
void OnDeinit(const int reason)
  {

  }
//========================================================================================================================================================================//
void OnTick()
  {
   isthereactiveorder();
   cheackmacross();
//---
   if((canbuy==true)&&(CntBuy==0))
     {
      opennew(OP_BUY);
     }
//---
   if((cansell==true)&&(CntSell==0))
     {
      opennew(OP_SELL);
     }
  }
//========================================================================================================================================================================//
void isthereactiveorder()
  {
   CntBuy=0;
   CntSell=0;
//---
   for(int i = 0 ; i < OrdersTotal() ; i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
        {
         Print("ERROR - Unable to select the order - ",GetLastError());
         break;
        }
      if(OrderSymbol()==Symbol() && OrderType() == OP_BUY)
         CntBuy++;
      if(OrderSymbol()==Symbol() && OrderType() == OP_SELL)
         CntSell++;
     }
  }
//========================================================================================================================================================================//
double calculateLotSize(double stopLoss,double Risk)
  {
// Fetch some symbol properties
   double lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double minLot  = MarketInfo(Symbol(), MODE_MINLOT);
   double maxLot  = MarketInfo(Symbol(), MODE_MAXLOT);
   double tickVal = MarketInfo(Symbol(), MODE_TICKVALUE);
// Calculate the actual lot size
   double lotSize = AccountBalance() * Risk / 100 / (stopLoss * tickVal);
//---
   return MathMin(
             maxLot,
             MathMax(
                minLot,
                NormalizeDouble(lotSize / lotStep, 0) * lotStep
             )
          );
  }
//========================================================================================================================================================================//
void opennew(int ordertype)
  {
   RefreshRates();
   double openprice=0;
   double closeprice=0;
   double stopp=0;
   double takep=0;
   bool OrdrSend=false;
//---
   if(ordertype==OP_BUY)
     {
      openprice=Ask;
      stopp=openprice-(sl*10*Point);
      takep=openprice+(tp*10*Point);
     }
//---
   if(ordertype==OP_SELL)
     {
      openprice=Bid;
      stopp=openprice+(sl*10*Point);
      takep=openprice-(tp*10*Point);
     }
//---
   OrdrSend=OrderSend(Symbol(),ordertype,calculateLotSize(sl*10,risk),openprice,10,NormalizeDouble(stopp,Digits),NormalizeDouble(takep,Digits),NULL,0,0,clrBlue);
  }
//========================================================================================================================================================================//
void cheackmacross()
  {
   canbuy=false;
   cansell=false;
//---
   double currMA1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,1);
   double prevMA1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,2);
   double currMA2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,1);
   double prevMA2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,2);
//---
   if(prevMA1>prevMA2 && currMA2>currMA1)
     {
      canbuy=true;
     }
//---
   if(prevMA1<prevMA2 && currMA2<currMA1)
     {
      cansell=true;
     }

  }
//========================================================================================================================================================================//
